*:*****************************************************************************
*:
*: Procedure file: C:\CLIPPER5\MIKE\COLOUR.PRG
*:
*:         System: Colour Finder for setcolor()
*:         Author: Mike Rahilly
*:      Copyright (c) 1993, Mike Rahilly
*:  Last modified: 07/26/93      2:40
*:
*:  Procs & Fncts: MAIN
*:               : COLOUR_HELP
*:
*:          Calls: MAIN               (procedure in COLOUR.PRG)
*:
*:      Clipper colour /a/m/n/w
*:      rtlink fi colour
*:
*:      Documented 07/26/93 at 02:44                SNAP!  version 5.02
*:*****************************************************************************
#include "inkey.ch"
#include "setcurs.ch"
#include "set.ch"

*!*****************************************************************************
*!
*!      Procedure: MAIN
*!
*!      Called by: COLOUR.PRG
*!
*!          Calls: SETBLINK()         (function  in ?)
*!               : DISPBEGIN()        (function  in ?)
*!               : PADC()             (function  in ?)
*!               : DISPEND()          (function  in ?)
*!               : COLOUR_HELP        (procedure in COLOUR.PRG)
*!
*!*****************************************************************************
PROCEDURE main
LOCAL i, j, k               // loop counters
LOCAL ncount := 0
LOCAL nrow := 0, ncol := 0  // screen position
LOCAL acolours := {{0,'N','Black'},{1,'B','Blue'},;
   {2,'G','Green'},{3,'BG','Cyan'},;
   {4,'R','Red'},{5,'RB','Magenta'},;
   {6,'GR','Brown'},{7,'W','White'},;
   {8,'N+','Grey'},{9,'B+','Bright Blue'},;
   {10,'G+','Bright Green'},{11,'BG+','Bright Cyan'},;
   {12,'R+','Bright Red'},{13,'RB+','Bright Magenta'},;
   {14,'GR+','Yellow'},{15,'W+','Bright White'}}

LOCAL aselections := {}
// Array holding
// 1 colour number 0 to 255
// 2 colour string e.g. "W/B+"
// 3 character used in savescreen()
//   to represent the colour
// 4 Row for choice display
// 5 Column for choice display
// 6 Colour description e.g. "Bright White on Red"

LOCAL nsayget := {48,32,24}
// position in the array of the three colours
// 1 is the Say colour
// 2 is the Get colour
// 3 is the Inactive Get colour

LOCAL nwhich := 1
// which of the three colours we are working with
// in the colour picking section

LOCAL nkey
LOCAL cthescreen

Setcursor(SC_NONE)
SET(_SET_SCOREBOARD,.F.)

// Build array of colours

// Outer loop of Intensities
FOR i = 1 TO 2
   // Outer loop of Background Colours
   FOR j = 1 TO 8
      // Jnner loop of Foreground Colours
      FOR k = 1 TO 16
         AADD(aselections,{ncount,acolours[K,2]+'/'+acolours[J,2],CHR(ncount),;
            nrow+1,ncol,acolours[K,3]+" on "+acolours[J,3]})

         IF i = 2
            aselections[nCount+1,2] := aselections[nCount+1,2] + "*"
            aselections[nCount+1,6] := aselections[nCount+1,6] + " Blinking"
         ENDIF

         ++ncount
         ++nrow
      NEXT k
      ncol := ncol + 5
      nrow := 0
   NEXT j
NEXT i

// Display the colours
CLEAR SCREEN
setblink(.F.)
SETCOLOR('')
@ 00,00 SAY '/--------------------------------------\' + ;
   '/--------------------------------------\'
@ 00,13 SAY ' Normal Colour ' COLOR 'w+/n'
@ 00,53 SAY ' SetBlink(.F.) ' COLOR 'w+/n'

FOR i = 1 TO 256
   SETCOLOR(aselections[I,2])
   @ aselections[I,4],aselections[I,5];
      SAY ' '+STR(aselections[I,1],3)+' '
NEXT i

SETCOLOR('')
@24,71 SAY 'Help = F1'

// save screen and start playing
cthescreen := SAVESCREEN(1,0,Maxrow(),MAXCOL())

DO WHILE .T.
   dispbegin()
   RESTSCREEN(1,0,Maxrow(),MAXCOL(),cthescreen)
   SETCOLOR("W+/N")

   @ aselections[nSayGet[1],4], aselections[nSayGet[1],5];
      SAY '['+STR(aselections[nSayGet[1],1],3)+']'

   @ aselections[nSayGet[2],4], aselections[nSayGet[2],5];
      SAY '<'+STR(aselections[nSayGet[2],1],3)+'>'

   @ aselections[nSayGet[3],4], aselections[nSayGet[3],5];
      SAY '{'+STR(aselections[nSayGet[3],1],3)+'}'

   @ 18, 0 SAY padc("Setcolor('"+aselections[nSayGet[1],2]+","+;
      aselections[nSayGet[2],2]+",NIL,NIL,"+;
      aselections[nSayGet[3],2] +"')",80)



   @ 20,12 SAY ' [  Screen Say  ] ' COLOR aselections[nSayGet[1],2]
   @ 20,31 SAY ' <  Active Get  > ' COLOR aselections[nSayGet[2],2]
   @ 20,50 SAY ' { Inactive Get } ' COLOR aselections[nSayGEt[3],2]

   @ 19,12 + (nwhich-1) * 19 SAY 'Ŀ'
   @ 21,12 + (nwhich-1) * 19 SAY ''

   @ 22, 0 SAY padc(aselections[nSayGet[nwhich],6],80)
   @ 23, 0 SAY padc('Savescreen character = '+aselections[nSayGet[nwhich],3],80)

   dispend()

   nkey := INKEY(0)

   DO CASE

   CASE nkey == K_ESC
      QUIT

   CASE nkey == K_SPACE
      IF setblink()
         setblink(.F.)
         @ 00,53 SAY ' SetBlink(.F.) ' COLOR 'w+/n'
      ELSE
         setblink(.T.)
         @ 00,53 SAY ' SetBlink(.T.) ' COLOR 'w+/n'
      ENDIF

   CASE nkey == K_RIGHT
      nsayget[nWhich] := IIF(nsayget[nWhich] + 16 <= 256,;
         nsayget[nWhich] + 16, nsayget[nWhich] - 240)

   CASE nkey == K_LEFT
      nsayget[nWhich] := IIF(nsayget[nWhich] - 16 >= 1,;
         nsayget[nWhich] - 16,nsayget[nWhich] +240)

   CASE nkey == K_DOWN
      nsayget[nWhich] := IIF(nsayget[nWhich]/16<>INT(nsayget[nWhich]/16),;
         nsayget[nWhich] + 1, nsayget[nWhich] -15)

   CASE nkey == K_UP
      nsayget[nWhich] := IIF((nsayget[nWhich]-1)/16<>INT((nsayget[nWhich]-1)/16);
         .AND. nsayget[nWhich]<>1, nsayget[nWhich] -1, nsayget[nWhich] + 15)

   CASE nkey == K_TAB
      nwhich := IIF(nwhich<>3, nwhich + 1, 1)

   CASE nkey == K_F1
      colour_help()

   ENDCASE
ENDDO


*!*****************************************************************************
*!
*!      Procedure: COLOUR_HELP
*!
*!      Called by: MAIN               (procedure in COLOUR.PRG)
*!
*!          Calls: SETBLINK()         (function  in ?)
*!
*!*****************************************************************************
PROC colour_help
LOCAL getlist  := {}
LOCAL scr      := SAVESCREEN(00,00,Maxrow(),MAXCOL())
LOCAL colr     := SETCOLOR('g+/n*')
LOCAL oldblink := setblink(.F.)

@ 01,10,24,69 BOX '͸Գ '
@ 03,12 SAY '                         COLOUR' COLOR 'w+/n*'
@ 05,12 SAY 'This program helps you in selecting colour combinations'
@ 06,12 SAY 'for your Clipper Applications. The keys are as follows:'
@ 08,12 SAY ' ARROW KEYS  ' COLOR 'gr+/n*'
@ 08,25 SAY 'Positions the current Colour Selector Box'
@ 09,12 SAY '    TAB       ' COLOR 'gr+/n*'
@ 09,25 SAY 'Selects the Colour Selector box'
@ 10,12 SAY '   RETURN     ' COLOR 'gr+/n*'
@ 10,25 SAY 'Lets you try out your colour choices'
@ 11,12 SAY '   SPACE      ' COLOR 'gr+/n*'
@ 11,25 SAY 'Toggles the SetBlink bit'
@ 12,12 SAY '    ESC       ' COLOR 'gr+/n*'
@ 12,25 SAY 'Exits program'
@ 13,12 SAY '    F1        ' COLOR 'gr+/n*'
@ 13,25 SAY 'This Help Menu'
@ 15,12 SAY '      Original program idea by John Peshar' COLOR 'bg+/n*'
@ 16,12 SAY '      PO Box 145 The Junction NSW 2291 Australia' COLOR 'bg+/n*'
@ 18,12 SAY '      Updated program by Mike Rahilly          ' COLOR 'bg+/n*'
@ 19,12 SAY '      106 1750 Lawrence Ave. W.' COLOR 'bg+/n*'
@ 20,12 SAY '      Toronto, Ontario' COLOR 'bg+/n*'
@ 21,12 SAY '      Canada' COLOR 'bg+/n*'
@ 22,12 SAY '      M6L 3C4' COLOR 'bg+/n*'
@ 23,12 SAY '      CompuServ ID 72427,2123' COLOR 'bg+/n*'

INKEY(0)
RESTSCREEN(00,00,Maxrow(),MAXCOL(),scr)
SETCOLOR(colr)
setblink(oldblink)
RETURN

*: EOF: COLOUR.PRG
